require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/meth/methodologies', type: :request do
  let(:valid_attributes) { {name: 'Method1'} }
  let(:invalid_attributes) { {name: ''} }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Meth::Methodology.create! valid_attributes
      get meth_methodologies_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      meth_methodology = Meth::Methodology.create! valid_attributes
      get meth_methodology_url(meth_methodology)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_meth_methodology_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      meth_methodology = Meth::Methodology.create! valid_attributes
      get edit_meth_methodology_url(meth_methodology)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Meth::Methodology' do
        expect {
          post meth_methodologies_url, params: { meth_methodology: valid_attributes }
        }.to change(Meth::Methodology, :count).by(1)
      end

      it 'redirects to the created meth_methodology' do
        post meth_methodologies_url, params: { meth_methodology: valid_attributes }
        expect(response).to redirect_to(edit_meth_methodology_url(@controller.instance_variable_get(:@methodology)))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Meth::Methodology' do
        expect {
          post meth_methodologies_url, params: { meth_methodology: invalid_attributes }
        }.to change(Meth::Methodology, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post meth_methodologies_url, params: { meth_methodology: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {name: 'Method2-nouveau nom'} }

      it 'updates the requested meth_methodology' do
        meth_methodology = Meth::Methodology.create! valid_attributes
        patch meth_methodology_url(meth_methodology), params: { meth_methodology: new_attributes }
        meth_methodology.reload
        expect(meth_methodology.name).to eq 'Method2-nouveau nom'
      end

      it 'redirects to the meth_methodologies list' do
        meth_methodology = Meth::Methodology.create! valid_attributes
        patch meth_methodology_url(meth_methodology), params: { meth_methodology: new_attributes }
        meth_methodology.reload
        expect(response).to redirect_to(meth_methodologies_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        meth_methodology = Meth::Methodology.create! valid_attributes
        patch meth_methodology_url(meth_methodology), params: { meth_methodology: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested meth_methodology and associated step_tools' do
      nb_step_tool = Meth::StepTool.all.count
      meth_methodology = FactoryBot.create(:methodology, :with_step_1, name: 'Method to delete')

      expect {
        delete meth_methodology_url(meth_methodology)
      }.to change(Meth::Methodology, :count).by(-1)

      expect(Meth::StepTool.all.count).to eq nb_step_tool
    end

    it 'redirects to the meth_methodologies list' do
      meth_methodology = Meth::Methodology.create! valid_attributes
      delete meth_methodology_url(meth_methodology)
      expect(response).to redirect_to(meth_methodologies_url)
    end
  end
end
